#ifndef HINT_H
#define HINT_H

#include <string>
#include <fstream>
#include <cassert>
#include <set>
#include <sstream>
#include <iostream>
#include <stdlib.h>
#include <limits.h>
#include <stdio.h>
#include <map>
#include "fileutil.h"
using namespace std;

class Hint {

 public:
  Hint():bucketSize(100),numHashingBits(15){}

  void addToFastSlicing(int dim) {
          fastSlicing.insert(dim);
  }

  bool containsFastSlicing(int dim) const  {
          return fastSlicing.find(dim) != fastSlicing.end();
  }  

  int lazyRotations();

  void setBucketSize(int size){this->bucketSize = size;}

  int getBucketSize(){return this->bucketSize;}

  void setNumHashingBits(int num){this->numHashingBits = num;}

  int getNumHashingBits(){return this->numHashingBits;}

  void setFastSlicing(const set<int> & inFastSlicing){fastSlicing = inFastSlicing;}
  set<int> getFastSlicing() const {return fastSlicing;}
 protected:

 private:
  set<int> fastSlicing; // a "set" is more appropriate than a vector here
  int bucketSize;
  int numHashingBits;
  enum{lazyRots = 1};

};

 int Hint::lazyRotations(){
    if(lazyRots)
	return 1;
    else
	return 0;
}
#endif
